print("OCG - mod")

minetest.register_node("ocg:squares", {
    description = "OCG squares brick",
    tiles = {
        "minetest_block.png",
        "minetest_block.png",
        "minetest_block.png",
        "minetest_block.png",
        "minetest_block.png",
        "minetest_block.png"
    },
})

minetest.register_node("ocg:block_zero", {
    description = "OCG block with one dot",
    tiles = {
        "block_zero.png",
		"block_zero.png",
		"block_zero.png",
		"block_zero.png",
		"block_zero.png",
		"block_zero.png"
    },
})

minetest.register_node("ocg:block_one", {
    description = "OCG block with one dot",
    tiles = {
        "block_one.png",
		"block_one.png",
		"block_one.png",
		"block_one.png",
		"block_one.png",
		"block_one.png"
    },
})

minetest.register_node("ocg:block_two", {
    description = "OCG block with two dot",
    tiles = {
        "block_two.png",
		"block_two.png",
		"block_two.png",
		"block_two.png",
		"block_two.png",
		"block_two.png"
    },
})

minetest.register_node("ocg:block_three", {
    description = "OCG block with three dots",
    tiles = {
        "block_three.png",
		"block_three.png",
		"block_three.png",
		"block_three.png",
		"block_three.png",
		"block_three.png"
    },
})

minetest.register_node("ocg:block_four", {
    description = "OCG block with four dots",
    tiles = {
        "block_four.png",
		"block_four.png",
		"block_four.png",
		"block_four.png",
		"block_four.png",
		"block_four.png"
    },
})

minetest.register_node("ocg:block_five", {
    description = "OCG block with five dots",
    tiles = {
        "block_five.png",
		"block_five.png",
		"block_five.png",
		"block_five.png",
		"block_five.png",
		"block_five.png"
    },
})

minetest.register_chatcommand("foo", {
    privs = {
        interact = true,
    },
    func = function(name, param)     -- name: singleplavyer
        return true, "You said " .. name .. " " .. param .. "!"
    end,
})

minetest.register_node(minetest.get_current_modname()..":test_block_1",
{
  description = "Test block 1.",
  tiles = {"^[colorize:#802BB1"}, 
})

--[[
minetest.register_on_joinplayer(function(player)
    minetest.set_node(player:get_pos(), {name="default:dirt"})
end)
--]]

-- ..............................................
-- ............. Hier geht's los.
-- ..............................................
-- ............. Funktion, mit Übergabewerten / Parametern, mit/ohne Rückgabewert 

function ausgabe(a, b)
	minetest.chat_send_all(a .. " " .. b)
end

function addiere(a, b)
	return a + b
end

minetest.register_chatcommand("test", {
    func = function(playername, param)
		ausgabe(5, 3)
		minetest.chat_send_all(addiere(5, 3))
		return true, "done"
    end,
})

--[[

Ausgabe:
5 3
8
done

--]]


-- ..............................................
-- ..................... Hello World auf 2 Arten

minetest.register_chatcommand("hello1", {
    func = function(playername, param)
		return true, "hello world!"
    end,
})

minetest.register_chatcommand("hello2", {
    func = function(playername, param)
		minetest.chat_send_all("hello world!")
		return true, "done"
    end,
})

-- ..............................................
-- .................. Den Spieler teleportieren

minetest.register_chatcommand("teleport1", {
    func = function(playername, param)
		local player = minetest.get_player_by_name(playername)
		player:set_pos({x=187.6,y=8.5,z=-118.7})
		return true, "done"
    end,
})

minetest.register_chatcommand("teleport2", {
    func = function(playername, param)
		local player = minetest.get_player_by_name(playername)
		player:set_pos({x=240.5,y=1.5,z=-65.2})
		return true, "done"
    end,
})

-- ..............................................
-- .......................... Springen

minetest.register_chatcommand("jump1", {
    func = function(playername, param)
		local player = minetest.get_player_by_name(playername)
		local pos = player:get_pos()
		player:set_pos({x = pos.x, y = pos.y+20, z = pos.z})
		return true, "done"
    end,
})

minetest.register_chatcommand("jump2", {
    func = function(playername, param)
		local player = minetest.get_player_by_name(playername)
		local pos = player:get_pos()
		-- slightly different from above
		local pos = {x = pos.x, y = pos.y-20, z = pos.z}
		player:set_pos(pos)
		return true, "done"
    end,
})

-- ..............................................
-- ......... Welchen Typ hat der Block unter mir?

minetest.register_chatcommand("get_blockbelow", {
    func = function(playername, param)
		local player = minetest.get_player_by_name(playername)
		local pos = player:get_pos()
		local node = minetest.get_node({x=pos.x, y=pos.y-1, z=pos.z})
		return true, node.name
    end,
})

-- ......... Blocktyp schreiben (wenn Blocktyp = "air" bedeutet das löschen)

minetest.register_chatcommand("set_blockbelow", {
    func = function(playername, param)
		local player = minetest.get_player_by_name(playername)
		local pos = player:get_pos()
		minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="air"})
		-- minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="sand"})
		-- minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="default:ice"})
		return true, "done"
    end,
})

-- ..............................................

-- gehe in die angegebene x,y - Richtung

function go(playername, x_arg, z_arg)
	local player = minetest.get_player_by_name(playername)
	local pos = player:get_pos()
	local pos = {x = pos.x + x_arg, y = pos.y, z = pos.z + z_arg}
	player:set_pos(pos)
end

-- gehe im Quadrat

minetest.register_chatcommand("go1", {
    func = function(playername, param)
		go(playername, 1, 0)
		go(playername, 0, -1)
		go(playername, -1, 0)
		go(playername, 0, 1)
		return true, "done"
    end,
})

-- gehe im Quadrat aber verzögert. Optional

minetest.register_chatcommand("go2", {
    func = function(playername, param)
		minetest.after(1, go, playername, 0, 1)
		minetest.after(2, go, playername, 0, -1)
		minetest.after(3, go, playername, -1, 0)
		minetest.after(4, go, playername, 0, 1)
		return true, "done"
    end,
})

-- ................... Gehe im Quadrat und hinterlasse "cobble"

minetest.register_chatcommand("go3", {
    func = function(playername, param)
		local player = minetest.get_player_by_name(playername)
		go(playername, 1, 0)
		local pos = player:get_pos()
		minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="default:cobble"})
		go(playername, 0, -1)
		local pos = player:get_pos()
		minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="default:cobble"})
		go(playername, -1, 0)
		local pos = player:get_pos()
		minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="default:cobble"})
		go(playername, 0, 1)
		local pos = player:get_pos()
		minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="default:cobble"})
		return true, "done"
    end,
})

-- ................... Gehe im Quadrat und hinterlasse "sand"

minetest.register_chatcommand("go4", {
    func = function(playername, param)
		local player = minetest.get_player_by_name(playername)
		go(playername, 1, 0)
		local pos = player:get_pos()
		minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="sand"})
		go(playername, 0, -1)
		local pos = player:get_pos()
		minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="sand"})
		go(playername, -1, 0)
		local pos = player:get_pos()
		minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="sand"})
		go(playername, 0, 1)
		local pos = player:get_pos()
		minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="sand"})
		return true, "done"
    end,
})

-- ..............................................

-- ................... Baue Turm mit 3 Bausteinen

minetest.register_chatcommand("build1", {
    func = function(playername, param)
		local player = minetest.get_player_by_name(playername)
		local pos = player:get_pos()
		minetest.set_node({x=pos.x+1,y=pos.y,z=pos.z}, {name="default:brick"})
		minetest.set_node({x=pos.x+1,y=pos.y+1,z=pos.z}, {name="default:brick"})
		minetest.set_node({x=pos.x+1,y=pos.y+2,z=pos.z}, {name="default:brick"})
		return true, "done"
    end,
})

-- ................... Lösche den obigen Turm

minetest.register_chatcommand("build2", {
    func = function(playername, param)
		local player = minetest.get_player_by_name(playername)
		local pos = player:get_pos()
		minetest.set_node({x=pos.x+1,y=pos.y,z=pos.z}, {name="air"})
		minetest.set_node({x=pos.x+1,y=pos.y+1,z=pos.z}, {name="air"})
		minetest.set_node({x=pos.x+1,y=pos.y+2,z=pos.z}, {name="air"})
		return true, "done"
    end,
})

-- ..............................................

-- .......... Demonstriere "Table", ".." Operator, Table-Zugriff über Index

minetest.register_chatcommand("all_directions", {
    func = function(playername, param)
		local directions = {"n", "s", "w", "e"}
		return true, directions[1] .. "/" .. directions[2] .. "/" .. directions[3] .. "/" .. directions[4]
    end,
})

-- .......... 5x5 Block setzen

minetest.register_chatcommand("build3", {
    func = function(playername, param)
		local player = minetest.get_player_by_name(playername)
		local pos = player:get_pos()
		for i = 1, 5 do
			for j = 0, 4 do
				for k = 0, 4 do
					minetest.set_node({x=pos.x+i,y=pos.y+j,z=pos.z+k}, {name="default:brick"})
				end
			end
		end
		return true, "done"
    end,
})

-- .......... 5x5 Block löschen

minetest.register_chatcommand("build4", {
    func = function(playername, param)
		local player = minetest.get_player_by_name(playername)
		local pos = player:get_pos()
		for i = 1, 5 do
			for j = 0, 4 do
				for k = 0, 4 do
					minetest.set_node({x=pos.x+i,y=pos.y+j,z=pos.z+k}, {name="air"})
				end
			end
		end
		return true, "done"
    end,
})

-- ................ Setze Blöcke laut Table:

minetest.register_chatcommand("build5", {
    func = function(playername, param)
		local player = minetest.get_player_by_name(playername)
		local pos = player:get_pos()
		local cube = {
		{{1,0,1,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0}},
		{{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0}},
		{{0,0,0,0,0},{0,1,0,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0}},
		{{0,0,0,0,0},{0,0,1,0,0},{0,0,0,0,0},{0,0,0,0,0},{0,0,0,0,0}},
		{{0,0,0,0,0},{0,0,0,0,0},{0,1,0,0,0},{0,1,0,0,0},{0,0,1,0,0}}}
		for i = 1, 5 do
			for j = 0, 4 do
				for k = 0, 4 do
					minetest.chat_send_all(cube[i][j+1][k+1])
					if cube[i][j+1][k+1] == 1 then
					minetest.set_node({x=pos.x+i,y=pos.y+j,z=pos.z+k}, {name="default:brick"})
					end
				end
			end
		end
		return true, "done"
    end,
})

-- .......... Ähnlich oben und demonstriere Zugriff auf zufälliges Element des Table
-- .......... math.random

minetest.register_chatcommand("random_direction", {
    func = function(playername, param)
		local directions = {"n", "s", "w", "e"}
		return true, directions[math.random(1, #directions)]
    end,
})

-- ..............................................
-- .......... Das folgende wird zur Wiederherstellung verwendet.
-- .......... Schreibt Sandblöcke. Überwindet keine Hindernisse.

function go_sand(playername, x_arg, z_arg)
	local player = minetest.get_player_by_name(playername)
	local pos = player:get_pos()
	local pos = {x = pos.x + x_arg, y = pos.y, z = pos.z + z_arg}
	local node = minetest.get_node(pos)
	if node.name == "air" then
		player:set_pos(pos)
		minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="default:sand"})
	end
end

minetest.register_chatcommand("sand", {
    func = function(playername, param)
		local player = minetest.get_player_by_name(playername)
		local directions = {"n", "s", "w", "e"}
		local pos_before = player:get_pos()
		for i = 1, 15000 do
			local pos = player:get_pos()
			local direction = directions[math.random(1, #directions)]
			if direction == "n" then go_sand(playername, 1, 0) 
			elseif direction == "s" then go_sand(playername, -1, 0)
			elseif direction == "w" then go_sand(playername, 0, -1)
			else go_sand(playername, 0, 1)
			end
		end
		player:set_pos(pos_before)
		return true, "done"
    end,
})

-- ..............................................

-- ........... "Random Walk"

function go_randwalk1(playername, x_arg, z_arg)
	local player = minetest.get_player_by_name(playername)
	local pos = player:get_pos()
	local pos = {x = pos.x + x_arg, y = pos.y, z = pos.z + z_arg}
	local node = minetest.get_node(pos)
	if node.name == "air" then
		player:set_pos(pos)
		minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="ocg:block_zero"})
	end
end

minetest.register_chatcommand("randwalk1", {
    func = function(playername, param)
		local player = minetest.get_player_by_name(playername)
		local directions = {"n", "s", "w", "e"}
		for i = 1, 500 do
			local pos = player:get_pos()
			local direction = directions[math.random(1, #directions)]
			if direction == "n" then go_randwalk1(playername, 1, 0) 
			elseif direction == "s" then go_randwalk1(playername, -1, 0)
			elseif direction == "w" then go_randwalk1(playername, 0, -1)
			else go_randwalk1(playername, 0, 1)
			end
		end
		return true, "done"
    end,
})

-- ..............................................

-- ........... "Random Walk", block_one, block_two

function go_randwalk2(playername, x_arg, z_arg)
	local player = minetest.get_player_by_name(playername)
	local pos = player:get_pos()
	local pos = {x = pos.x + x_arg, y = pos.y, z = pos.z + z_arg}
	local node = minetest.get_node(pos)
	if node.name == "air" then
		player:set_pos(pos)
		node = minetest.get_node({ x = pos.x, y = pos.y-1, z = pos.z })
		--minetest.chat_send_all("node.name: " .. node.name)
		if node.name == "ocg:block_one" then
			minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="ocg:block_two"})
		else
			minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="ocg:block_one"})
		end
	end
end

minetest.register_chatcommand("randwalk2", {
    func = function(playername, param)
		local player = minetest.get_player_by_name(playername)
		local directions = {"n", "s", "w", "e"}
		for i = 1, 500 do
			local pos = player:get_pos()
			local direction = directions[math.random(1, #directions)]
			if direction == "n" then go_randwalk2(playername, 1, 0) 
			elseif direction == "s" then go_randwalk2(playername, -1, 0)
			elseif direction == "w" then go_randwalk2(playername, 0, -1)
			else go_randwalk2(playername, 0, 1)
			end
		end
		return true, "done"
    end,
})

-- ..............................................

-- ................ "Random Walk" mit block_one, block_two, ... block_five

function go3(playername, x_arg, z_arg)   -- also used from "ai" chat command
	local player = minetest.get_player_by_name(playername)
	local pos = player:get_pos()
	local pos = {x = pos.x + x_arg, y = pos.y, z = pos.z + z_arg}
	local node = minetest.get_node(pos)
	if node.name == "air" then
		player:set_pos(pos)
		node = minetest.get_node({ x = pos.x, y = pos.y-1, z = pos.z })
		--minetest.chat_send_all("node.name: " .. node.name)
		if node.name == "ocg:block_one" then
			minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="ocg:block_two"})
		elseif node.name == "ocg:block_two" then
			minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="ocg:block_three"})
		elseif node.name == "ocg:block_three" then
			minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="ocg:block_four"})
		elseif node.name == "ocg:block_four" then
			minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="ocg:block_five"})
		elseif node.name ~= "ocg:block_five" then
			minetest.set_node({x=pos.x,y=pos.y-1,z=pos.z}, {name="ocg:block_one"})
		end
	end
end

minetest.register_chatcommand("randwalk3", {
    func = function(playername, param)
		local player = minetest.get_player_by_name(playername)
		local directions = {"n", "s", "w", "e"}
		for i = 1, 500 do
			local pos = player:get_pos()
			local direction = directions[math.random(1, #directions)]
			if direction == "n" then go3(playername, 1, 0) 
			elseif direction == "s" then go3(playername, -1, 0)
			elseif direction == "w" then go3(playername, 0, -1)
			else go3(playername, 0, 1)
			end
		end
		return true, "done"
    end,
})

-- ..............................................

-- ........... ai lösungsverfahren, suche ausgang aus irrgarten
-- ........... vermeide zonen die man schon besucht hat

function node_val(node_name)
	if node_name == "ocg:block_five" then return 5
	elseif node_name == "ocg:block_four" then return 4
	elseif node_name == "ocg:block_three" then return 3
	elseif node_name == "ocg:block_two" then return 2
	elseif node_name == "ocg:block_one" then return 1
	else return 0
	end
end

minetest.register_chatcommand("ai", {
    func = function(playername, param)
		local player = minetest.get_player_by_name(playername)
		for i = 1, 500 do
			local pos = player:get_pos()
			local current_opt_val_direction = ""
			local current_opt_val = 6
			-- "n"  1, 0
			local node_n = minetest.get_node({ x = pos.x+1, y = pos.y, z = pos.z })
			local node_n_floor = minetest.get_node({ x = pos.x+1, y = pos.y-1, z = pos.z })
			local node_val_n = node_val(node_n_floor.name)
			if node_n.name == "air" and node_val_n < current_opt_val then
				current_opt_val = node_val_n
				current_opt_val_direction = "n"
			end
			-- "s" -1, 0
			local node_s = minetest.get_node({ x = pos.x-1, y = pos.y, z = pos.z })
			local node_s_floor = minetest.get_node({ x = pos.x-1, y = pos.y-1, z = pos.z })
			local node_val_s = node_val(node_s_floor.name)
			if node_s.name == "air" and node_val_s < current_opt_val then
				current_opt_val = node_val_s
				current_opt_val_direction = "s"
			end
			-- "w"  0,-1
			local node_w = minetest.get_node({ x = pos.x, y = pos.y, z = pos.z-1 })
			local node_w_floor = minetest.get_node({ x = pos.x, y = pos.y-1, z = pos.z-1 })
			local node_val_w = node_val(node_w_floor.name)
			if node_w.name == "air" and node_val_w < current_opt_val then
				current_opt_val = node_val_w
				current_opt_val_direction = "w"
			end
			-- "e"  0, 1
			local node_e = minetest.get_node({ x = pos.x, y = pos.y, z = pos.z+1 })
			local node_e_floor = minetest.get_node({ x = pos.x, y = pos.y-1, z = pos.z+1 })
			local node_val_e = node_val(node_e_floor.name)
			if node_e.name == "air" and node_val_e < current_opt_val then
				current_opt_val = node_val_e
				current_opt_val_direction = "e"
			end
			--
			minetest.chat_send_all(current_opt_val .. " // " .. current_opt_val_direction)
			--
			if current_opt_val_direction == "n" then go3(playername, 1, 0) 
			elseif current_opt_val_direction == "s" then go3(playername, -1, 0)
			elseif current_opt_val_direction == "w" then go3(playername, 0, -1)
			elseif current_opt_val_direction == "e" then go3(playername, 0, 1)
			else minetest.chat_send_all("???")
			end
		end
		return true, "done"
    end,
})

-- ..............................................
-- ..............................................
